import multiprocessing as mp
import time
from model import *
from modelvariants import *
import sys

def experiment(s):
    expname, n, icname, mu_arr, track_times, resolution = arguments
    if not "replacement" in expname and not "additive" in expname:
        main(expname, n, icname, mu_arr, s, track_times, resolution=resolution, verbose=False)
    else:
        mainvariants(expname, n, icname, mu_arr, s, track_times, resolution=resolution, verbose=False)
    return s

def prepare(arguments):
    n, tfinal, lowerseed, higherseed = [int(arguments[k]) for k in [1,3,6,7]]
    mu = float(arguments[2])
    resolution = arguments[5]
    icname = arguments[4]
    track_times = [int(0), int(1e5)] if tfinal==100000 else [int(0),int(1e4),int(1e5),int(1e6)] 
    mu_arr = [mu]

    expname = resolution+"Res_"
    expname = expname + sys.argv[8]

    #lowerseed = 0
    #higherseed = 100
    seeds = [k for k in range(lowerseed, higherseed)]
    #print(seeds)
    return [expname, n, icname, mu_arr, track_times, resolution], seeds
    

if __name__=="__main__":
    s0 = time.time()
    print(sys.argv)
    arguments, seeds = prepare(sys.argv)
    print(arguments)

    print("CPU units: ", mp.cpu_count(), " using ", min(mp.cpu_count(), 32))
    with mp.Pool(processes=min(mp.cpu_count(), 32)) as p:
        results = p.map(experiment, seeds)

    s1 = time.time()
    print("{} min {} sec".format(int((s1-s0)/60), int(s1-s0)%60 ))

